﻿Imports System.IO
Imports System.Text
Imports System.Collections
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.Runtime.Serialization

Public Class Form1

    'Public mstrSaveFile As String, mstrData, ObjektList As New List(Of Object)

    'Private Sub bSaveEntry_Click(sender As Object, e As EventArgs) Handles bSaveEntry.Click
    '    Dim SelParts As List(Of Object) = SelDir(ListBox1.SelectedItem.ToString())

    '    Dim F As Runtime.Serialization.Formatters.Binary.BinaryFormatter
    '    Dim s As IO.Stream
    '    F = New Runtime.Serialization.Formatters.Binary.BinaryFormatter()
    '    s = New IO.FileStream("C:\Tempeloid\FileName.bin", IO.FileMode.Create, IO.FileAccess.Write, IO.FileShare.None)
    '    F.Serialize(s, SelParts)
    '    s.Close()
    'End Sub

    'Private Sub bLoadEntry_Click(sender As Object, e As EventArgs) Handles bLoadEntry.Click
    '    Dim f As Runtime.Serialization.Formatters.Binary.BinaryFormatter
    '    Dim s As IO.Stream
    '    f = New Runtime.Serialization.Formatters.Binary.BinaryFormatter()
    '    s = New IO.FileStream("C:\Tempeloid\FileName.bin", IO.FileMode.Open, IO.FileAccess.Read, IO.FileShare.None)
    '    Dim SelParts As List(Of Object) = DirectCast(f.Deserialize(s), Object)
    '    s.Close()
    '    Dim SelPartsName As String = "Blub"
    '    SelDir.Add(SelPartsName, SelParts)
    '    ListBox1.Items.Add(SelPartsName)
    'End Sub

    Public MySE As SolidEdgeFramework.Application, SelDir As New Dictionary(Of String, Object)

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        SEconnect()
        OleMessageFilter.Register()
        Me.Top = My.Settings.Top
        Me.Left = My.Settings.Left
    End Sub



    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        EndDo()
        My.Settings.Top = Me.Top
        My.Settings.Left = Me.Left
        MySE = Nothing
        OleMessageFilter.Revoke()
    End Sub

    Private Sub bSaveSel_Click(sender As Object, e As EventArgs) Handles bSaveSel.Click

        Dim SelParts As New List(Of Object)
        'SelParts.Clear()
        'For Each occ In MySE.ActiveSelectSet
        '    MsgBox(occ.Name)
        'Next

        For i = 1 To MySE.ActiveSelectSet.Count
            SelParts.Add(MySE.ActiveSelectSet.Item(i))
        Next

        Dim Name As String = tName.Text
        If Name = "" Then
            Name = "Auswahl"
        End If

        Dim SelPartsName As String = Name & " ( " & SelParts.Count & " Teile - " & Now() & " )"
        SelDir.Add(SelPartsName, SelParts)
        ListBox1.Items.Add(SelPartsName)

    End Sub

    Private Sub bLoadSel_Click(sender As Object, e As EventArgs) Handles bLoadSel.Click

        If IsNothing(ListBox1.SelectedItem) Then
            Exit Sub
        End If

        Dim myAssembly As SolidEdgeAssembly.AssemblyDocument
        myAssembly = MySE.ActiveDocument
        Try
            If cbAdd.Checked = False Then
                myAssembly.SelectSet.RemoveAll()
            End If
            'myAssembly.UpdatePathfinder(3) 'seSuspend 
            ''MySE.StartCommand(10831)
            'MySE.Application.ScreenUpdating = False
            'MySE.Interactive = False
            'MySE.ActiveSelectSet.RemoveAll()
            MySE.ActiveSelectSet.SuspendDisplay()
            Dim SelParts As List(Of Object) = SelDir(ListBox1.SelectedItem.ToString())
            For Each i In SelParts
                MySE.ActiveSelectSet.Add(i)
            Next
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            myAssembly.UpdatePathfinder(4)
            'MySE.Application.ScreenUpdating = True
            'MySE.Interactive = True
            MySE.ActiveSelectSet.ResumeDisplay()
            MySE.StartCommand(45000)
        End Try
    End Sub

    Private Sub SEconnect()
        Try
            MySE = GetObject(, "Solidedge.Application")
            Dim mySedoc As Object = MySE.ActiveDocument
            'If Microsoft.VisualBasic.Left(MySE.Version, 3) > "109" Then
            '    MsgBox("Das Programm kann nicht gestartet werden, da " & MySE.Application.Name & " die 32bit API nicht mehr unterstützt.", MsgBoxStyle.Critical)
            '    Environment.Exit(0)
            'End If
        Catch ex As Exception
            MsgBox("Solid Edge nicht gestartet oder keine Datei geladen! Daher wird dieses Macro beendet.",, Me.Text)
            Environment.Exit(0)
        End Try
    End Sub

    Function StartDo()
        On Error Resume Next
        StartDo = True
        If MySE.ActiveDocument.Type = 3 Then     '1 = *.prt / 2 = *.dft / 3 = *.asm / 4 = *.psm
            MySE.ActiveDocument.UpdatePathfinder(3) 'seSuspend 
        Else
            'StartDo = False
            'MsgBox("Dieses Tool funktioniert nur mit einer Zusammenstellung.", MsgBoxStyle.Information)
            'Exit Function
        End If
        On Error GoTo 0
        MySE.Application.ScreenUpdating = False
        MySE.Interactive = False
    End Function

    Private Sub bSelDelete_Click(sender As Object, e As EventArgs) Handles bSelDelete.Click
        Try
            ListBox1.Items.Remove(ListBox1.SelectedItem)
        Catch ex As Exception
        End Try
    End Sub

    Private Sub bInvert_Click(sender As Object, e As EventArgs)
        MySE.ActiveSelectSet.SuspendDisplay()
        Dim SelParts As New List(Of Object)
        For i = 1 To MySE.ActiveSelectSet.Count
            SelParts.Add(MySE.ActiveSelectSet.Item(i))
        Next
        MySE.ActiveSelectSet.AddAll()
        For Each i In SelParts
            MySE.ActiveSelectSet.Remove(i)
        Next
        MySE.ActiveSelectSet.ResumeDisplay()
        MySE.StartCommand(45000)
    End Sub

    Private Sub bHideAll_Click(sender As Object, e As EventArgs) Handles bHideAll.Click

        If StartDo() = False Then
            Exit Sub
        End If
        SEPartVisibleOrActiv(MySE.ActiveDocument, True, False, False, True, False)
        EndDo()

    End Sub

    Private Sub bShowAll_Click(sender As Object, e As EventArgs) Handles bShowAll.Click

        If StartDo() = False Then
            Exit Sub
        End If
        SEPartVisibleOrActiv(MySE.ActiveDocument, True, True, False, True)
        EndDo()

    End Sub


    Function SEPartVisibleOrActiv(Part As Object,
                           Optional Visible As Boolean = True,
                           Optional VisibleTrue As Boolean = True,
                           Optional Activ As Boolean = True,
                           Optional ActivTrue As Boolean = True,
                           Optional VisibleShow As Boolean = True)

        On Error GoTo EndFunction

        For Each occ In Part.Occurrences
            If occ.Subassembly = True Then
                If Visible = True Then
                    If VisibleShow = True Then
                        'Beim ausblenden die SubAssy nicht ausblenden
                        occ.Visible = VisibleTrue
                    End If
                    SEPartVisibleSubOcc(occ, Visible, VisibleTrue, VisibleShow)
                End If
                If Activ = True Then
                    SEPartActivSubOcc(occ.OccurrenceDocument, Activ, ActivTrue)
                End If
            Else
                If InStr(occ.PartFileName.ToLower(), tbStdPartFolderName.Text.ToLower()) > 0 Then
                    'MySE.ActiveDocument.SelectSet.add(occ)
                    If Visible = True Then
                        occ.Visible = VisibleTrue
                    End If
                    If Activ = True Then
                        occ.Activate = ActivTrue
                    End If
                End If
            End If
        Next

EndFunction:

        On Error Resume Next

    End Function



    Function SEPartVisibleSubOcc(Part As Object,
                           Optional Visible As Boolean = True,
                           Optional VisibleTrue As Boolean = True,
                           Optional VisibleShow As Boolean = True)

        On Error GoTo EndFunction

        For Each occ In Part.SubOccurrences
            If occ.Subassembly = True Then
                If VisibleShow = True Then
                    occ.Visible = VisibleTrue
                End If
                SEPartVisibleSubOcc(occ, Visible, VisibleTrue, VisibleShow)
            Else
                If InStr(occ.SubOccurrenceFileName.ToLower(), tbStdPartFolderName.Text.ToLower()) > 0 Then
                    If Visible = True Then
                        occ.Visible = VisibleTrue
                    End If
                End If
            End If
        Next

EndFunction:

        On Error Resume Next

    End Function

    Function SEPartActivSubOcc(Part As Object,
                           Optional Activ As Boolean = True,
                           Optional ActivTrue As Boolean = True)

        On Error GoTo EndFunction

        For Each occ In Part.Occurrences
            If occ.Subassembly = True Then
                SEPartActivSubOcc(occ.OccurrenceDocument, Activ, ActivTrue)
            Else
                If InStr(occ.PartFileName.ToLower(), tbStdPartFolderName.Text.ToLower()) > 0 Then
                    If Activ = True Then
                        occ.Activate = ActivTrue
                    End If
                End If
            End If
        Next

EndFunction:

        On Error Resume Next

    End Function

    Private Sub bSelect_Click(sender As Object, e As EventArgs) Handles bSelect.Click

        'If MsgBox("Dieser Befehl funktioniert noch nicht richtig und bei grossen Zusammenstellungen kann das bis 10 Minuten dauern, wirklich ausfüren?", vbYesNo) = vbNo Then
        '    Exit Sub
        'End If

        If StartDo() = False Then
            Exit Sub
        End If
        If cbAddToSelection.Checked = False Then
            MySE.ActiveSelectSet.RemoveAll()
        End If

        SEPartSelect(MySE.ActiveDocument, tbStdPartFolderName.Text)

        EndDo()

    End Sub

    Private Sub bShowRealyAll_Click(sender As Object, e As EventArgs) Handles bShowRealyAll.Click
        If StartDo() = False Then
            Exit Sub
        End If
        MySE.StartCommand(CommandID:=33071) 'Show All
        EndDo()
    End Sub

    Private Sub bHideRealyAll_Click(sender As Object, e As EventArgs) Handles bHideRealyAll.Click
        If StartDo() = False Then
            Exit Sub
        End If
        MySE.StartCommand(CommandID:=33072) 'Hide All
        EndDo()
    End Sub

    Function SEPartSelect(Assy As SolidEdgeAssembly.AssemblyDocument, SearchString As String) As Boolean
        Try
            SEPartSelect = True
            MySE.ActiveSelectSet.SuspendDisplay()
            For Each occ In Assy.Occurrences
                If occ.Subassembly = True Then
                    If SEPartSubSelect(occ, SearchString) = False Then
                        Exit Function
                    End If
                Else
                    If InStr(occ.PartFileName.ToLower(), SearchString.ToLower()) > 0 Then
                        MySE.ActiveSelectSet.Add(occ)
                    End If
                End If
            Next
        Catch ex As Exception
            MsgBox("Unbehandelter Fehler: " & ex.Message)
            SEPartSelect = False
            Exit Function
        Finally
            MySE.ActiveSelectSet.ResumeDisplay()
            MySE.StartCommand(45000)
        End Try
    End Function
    Function SEPartSubSelect(Part As Object, SearchString As String) As Boolean
        Try
            SEPartSubSelect = True
            For Each occ In Part.SubOccurrences
                If occ.Subassembly = True Then
                    SEPartSubSelect(occ, SearchString)
                Else
                    If InStr(occ.SubOccurrenceFileName.ToLower(), SearchString.ToLower()) > 0 Then
                        MySE.ActiveSelectSet.Add(occ.Reference)
                    End If
                End If
            Next
        Catch ex As Exception
            MsgBox("Unbehandelter Fehler: " & ex.Message)
            SEPartSubSelect = False
            Exit Function
        End Try
    End Function

    Private Sub Form1_Activated(sender As Object, e As EventArgs) Handles MyBase.Activated
        Me.Opacity = 1
    End Sub

    Private Sub Form1_Deactivate(sender As Object, e As EventArgs) Handles MyBase.Deactivate
        Try
            Me.Opacity = 0.7
        Catch ex As Exception

        End Try
    End Sub


    Sub EndDo()
        If MySE.ActiveDocument.Type = 3 Then     '1 = *.prt / 2 = *.dft / 3 = *.asm / 4 = *.psm
            MySE.ActiveDocument.UpdatePathfinder(4) 'seResume 
        End If
        MySE.Application.ScreenUpdating = True
        MySE.Interactive = True
    End Sub


End Class
